## juju-mongodb3.2 3.2.4

=== SConstruct ===
# -*- mode: python; -*-
import copy
import datetime
import errno
import json
import os
import re
import shlex
import shutil
import stat
import sys
import textwrap
import uuid
from buildscripts import utils
from buildscripts import moduleconfig

from mongo_scons_utils import (
    default_buildinfo_environment_data,
    default_variant_dir_generator,
    get_toolchain_ver,
)

import libdeps

EnsureSConsVersion( 2, 3, 0 )

def versiontuple(v):
    return tuple(map(int, (v.split("."))))

# --- OS identification ---
#
# This needs to precede the options section so that we can only offer some options on certain
# operating systems.

# This function gets the running OS as identified by Python
# It should only be used to set up defaults for options/variables, because
# its value could potentially be overridden by setting TARGET_OS on the
# command-line. Treat this output as the value of HOST_OS
def get_running_os_name():
    running_os = os.sys.platform
    if running_os.startswith('linux'):
        running_os = 'linux'
    elif running_os.startswith('freebsd'):
        running_os = 'freebsd'
    elif running_os.startswith('openbsd'):
        running_os = 'openbsd'
    elif running_os == 'sunos5':
        running_os = 'solaris'
    elif running_os == 'win32':
        running_os = 'windows'
    elif running_os == 'darwin':
        running_os = 'osx'
    else:
        running_os = 'unknown'
    return running_os

def env_get_os_name_wrapper(self):
    return env['TARGET_OS']

def is_os_raw(target_os, os_list_to_check):
    okay = False
    posix_os_list = [ 'linux', 'openbsd', 'freebsd', 'osx', 'solaris' ]

    for p in os_list_to_check:
        if p == 'posix' and target_os in posix_os_list:
            okay = True
            break
        elif p == target_os:
            okay = True
            break
    return okay

# This function tests the running OS as identified by Python
# It should only be used to set up defaults for options/variables, because
# its value could potentially be overridden by setting TARGET_OS on the
# command-line. Treat this output as the value of HOST_OS
def is_running_os(*os_list):
    return is_os_raw(get_running_os_name(), os_list)

def env_os_is_wrapper(self, *os_list):
    return is_os_raw(self['TARGET_OS'], os_list)

def add_option(name, **kwargs):

    if 'dest' not in kwargs:
        kwargs['dest'] = name

    if 'metavar' not in kwargs and kwargs.get('type', None) == 'choice':
        kwargs['metavar'] = '[' + '|'.join(kwargs['choices']) + ']'

    AddOption('--' + name, **kwargs)

def get_option(name):
    return GetOption(name)

def has_option(name):
    optval = GetOption(name)
    # Options with nargs=0 are true when their value is the empty tuple. Otherwise,
    # if the value is falsish (empty string, None, etc.), coerce to False.
    return True if optval == () else bool(optval)

def use_system_version_of_library(name):
    return has_option('use-system-all') or has_option('use-system-' + name)

# Returns true if we have been configured to use a system version of any C++ library. If you
# add a new C++ library dependency that may be shimmed out to the system, add it to the below
# list.
def using_system_version_of_cxx_libraries():
    cxx_library_names = ["tcmalloc", "boost"]
    return True in [use_system_version_of_library(x) for x in cxx_library_names]

def make_variant_dir_generator():
    memoized_variant_dir = [False]
    def generate_variant_dir(target, source, env, for_signature):
        if not memoized_variant_dir[0]:
            memoized_variant_dir[0] = env.subst('$BUILD_ROOT/$VARIANT_DIR')
        return memoized_variant_dir[0]
    return generate_variant_dir

# Options TODOs:
#
# - We should either alphabetize the entire list of options, or split them into logical groups
#   with clear boundaries, and then alphabetize the groups. There is no way in SCons though to
#   inform it of options groups.
#
# - Many of these options are currently only either present or absent. This is not good for
#   scripting the build invocation because it means you need to interpolate in the presence of
#   the whole option. It is better to make all options take an optional on/off or true/false
#   using the nargs='const' mechanism.
#

add_option('mute',
    help='do not display commandlines for compiling and linking, to reduce screen noise',
    nargs=0,
)

add_option('prefix',
    default='$BUILD_ROOT/install',
    help='installation prefix',
)

add_option('nostrip',
    help='do not strip installed binaries',
    nargs=0,
)

add_option('build-dir',
    default='#build',
    help='build output directory',
)

add_option('release',
    help='release build',
    nargs=0,
)

add_option('lto',
    help='enable link time optimizations (experimental, except with MSVC)',
    nargs=0,
)

add_option('dynamic-windows',
    help='dynamically link on Windows',
    nargs=0,
)

add_option('endian',
    choices=['big', 'little', 'auto'],
    default='auto',
    help='endianness of target platform',
    nargs=1,
    type='choice',
)

add_option('disable-minimum-compiler-version-enforcement',
    help='allow use of unsupported older compilers (NEVER for production builds)',
    nargs=0,
)

add_option('ssl',
    help='Enable SSL',
    nargs=0
)

add_option('wiredtiger',
    choices=['on', 'off'],
    const='on',
    default='on',
    help='Enable wiredtiger',
    nargs='?',
    type='choice',
)

js_engine_choices = ['mozjs', 'none']
add_option('js-engine',
    choices=js_engine_choices,
    default=js_engine_choices[0],
    help='JavaScript scripting engine implementation',
    type='choice',
)

add_option('server-js',
    choices=['on', 'off'],
    const='on',
    default='on',
    help='Build mongod without JavaScript support',
    type='choice',
)

add_option('libc++',
    help='use libc++ (experimental, requires clang)',
    nargs=0,
)

add_option('use-glibcxx-debug',
    help='Enable the glibc++ debug implementations of the C++ standard libary',
    nargs=0,
)

add_option('noshell',
    help="don't build shell",
    nargs=0,
)

add_option('safeshell',
    help="don't let shell scripts run programs (still, don't run untrusted scripts)",
    nargs=0,
)

add_option('dbg',
    choices=['on', 'off'],
    const='on',
    default='off',
    help='Enable runtime debugging checks',
    nargs='?',
    type='choice',
)

add_option('opt',
    choices=['on', 'off'],
    const='on',
    help='Enable compile-time optimization',
    nargs='?',
    type='choice',
)

add_option('sanitize',
    help='enable selected sanitizers',
    metavar='san1,san2,...sanN',
)

add_option('llvm-symbolizer',
    default='llvm-symbolizer',
    help='name of (or path to) the LLVM symbolizer',
)

add_option('durableDefaultOn',
    help='have durable default to on',
    nargs=0,
)

if is_running_os('linux') or is_running_os('windows'):
   defaultAllocator = 'tcmalloc'
else:
    defaultAllocator = 'system'

add_option('allocator',
    default=defaultAllocator,
    help='allocator to use (tcmalloc or system)',
)

add_option('gdbserver',
    help='build in gdb server support',
    nargs=0,
)

add_option('gcov',
    help='compile with flags for gcov',
    nargs=0,
)

add_option('smokedbprefix',
    help='prefix to dbpath et al. for smoke tests',
)

add_option('smokeauth',
    help='run smoke tests with --auth',
    nargs=0,
)

add_option('use-sasl-client',
    help='Support SASL authentication in the client library',
    nargs=0,
)

add_option('use-system-tcmalloc',
    help='use system version of tcmalloc library',
    nargs=0,
)

add_option('use-system-pcre',
    help='use system version of pcre library',
    nargs=0,
)

add_option('use-system-wiredtiger',
    help='use system version of wiredtiger library',
    nargs=0,
)

boost_choices = ['1.56']
add_option('internal-boost',
    choices=boost_choices,
    default=boost_choices[0],
    help='Specify internal boost version to use',
    type='choice',
)

add_option('system-boost-lib-search-suffixes',
    help='Comma delimited sequence of boost library suffixes to search',
)

add_option('use-system-boost',
    help='use system version of boost libraries',
    nargs=0,
)

add_option('use-system-snappy',
    help='use system version of snappy library',
    nargs=0,
)

add_option('use-system-valgrind',
    help='use system version of valgrind library',
    nargs=0,
)

add_option('use-system-zlib',
    help='use system version of zlib library',
    nargs=0,
)

add_option('use-system-stemmer',
    help='use system version of stemmer',
    nargs=0)

add_option('use-system-yaml',
    help='use system version of yaml',
    nargs=0,
)

add_option('use-system-asio',
    help="use system version of ASIO",
    nargs=0,
)

add_option('use-system-intel_decimal128',
    help='use system version of intel decimal128',
    nargs=0,
)

add_option('use-system-all',
    help='use all system libraries',
    nargs=0,
)

add_option('use-new-tools',
    help='put new tools in the tarball',
    nargs=0,
)

add_option('use-cpu-profiler',
    help='Link against the google-perftools profiler library',
    nargs=0,
)

add_option('build-fast-and-loose',
    choices=['on', 'off'],
    const='on',
    default='on',
    help='looser dependency checking, ignored for --release builds',
    nargs='?',
    type='choice',
)

add_option('disable-warnings-as-errors',
    help="Don't add -Werror to compiler command line",
    nargs=0,
)

add_option('variables-help',
    help='Print the help text for SCons variables',
    nargs=0,
)

add_option('osx-version-min',
    help='minimum OS X version to support',
)

win_version_min_choices = {
    'vista'   : ('0600', '0000'),
    'win7'    : ('0601', '0000'),
    'ws08r2'  : ('0601', '0000'),
    'win8'    : ('0602', '0000'),
    'win81'   : ('0603', '0000'),
}

add_option('win-version-min',
    choices=win_version_min_choices.keys(),
    default=None,
    help='minimum Windows version to support',
    type='choice',
)

add_option('cache',
    help='Use an object cache rather than a per-build variant directory (experimental)',
    nargs=0,
)

add_option('cache-dir',
    default='$BUILD_ROOT/scons/cache',
    help='Specify the directory to use for caching objects if --cache is in use',
)

add_option("experimental-decimal-support",
    choices=['on', 'off'],
    default='off',
    const='on',
    help="Enable experimental decimal128 type support",
    nargs='?',
)

def find_mongo_custom_variables():
    files = []
    for path in sys.path:
        probe = os.path.join(path, 'mongo_custom_variables.py')
        if os.path.isfile(probe):
            if not has_option('mute'):
                print "Using mongo variable customization file {0}".format(probe)
            files.append(probe)
    return files

add_option('variables-files',
    default=find_mongo_custom_variables(),
    help="Specify variables files to load",
)

link_model_choices = ['auto', 'object', 'static', 'dynamic', 'dynamic-strict']
add_option('link-model',
    choices=link_model_choices,
    default='object',
    help='Select the linking model for the project',
    type='choice'
)

variable_parse_mode_choices=['auto', 'posix', 'other']
add_option('variable-parse-mode',
    choices=variable_parse_mode_choices,
    default=variable_parse_mode_choices[0],
    help='Select which parsing mode is used to interpret command line variables',
    type='choice',
)

add_option('modules',
    help="Comma-separated list of modules to build. Empty means none. Default is all.",
)

try:
    with open("version.json", "r") as version_fp:
        version_data = json.load(version_fp)

    if 'version' not in version_data:
        print "version.json does not contain a version string"
        Exit(1)
    if 'githash' not in version_data:
        version_data['githash'] = utils.getGitVersion()

except IOError as e:
    # If the file error wasn't because the file is missing, error out
    if e.errno != errno.ENOENT:
        print "Error opening version.json: {0}".format(e.strerror)
        Exit(1)

=== src/third_party/wiredtiger/SConstruct ===
# -*- mode: python; -*-
import re
import os
import shutil
import subprocess
import sys
import tempfile
import textwrap
import distutils.sysconfig

EnsureSConsVersion( 2, 0, 0 )

if not os.sys.platform == "win32":
    print ("SConstruct is only supported for Windows, use build_posix for other platforms")
    Exit(1)

# Command line options
#
AddOption("--dynamic-crt", dest="dynamic-crt", action="store_true", default=False,
          help="Link with the MSVCRT DLL version")

AddOption("--enable-attach", dest="attach", action="store_true", default=False,
          help="Configure for debugger attach on failure.")

AddOption("--enable-diagnostic", dest="diagnostic", action="store_true", default=False,
          help="Configure WiredTiger to perform various run-time diagnostic tests. DO NOT configure this option in production environments.")

AddOption("--enable-lz4", dest="lz4", type="string", nargs=1, action="store",
          help="Use LZ4 compression")

AddOption("--enable-python", dest="lang-python", type="string", nargs=1, action="store",
          help="Build Python extension, specify location of swig.exe binary")

AddOption("--enable-snappy", dest="snappy", type="string", nargs=1, action="store",
          help="Use snappy compression")

AddOption("--enable-tcmalloc", dest="tcmalloc", type="string", nargs=1, action="store",
          help="Use TCMalloc for memory allocation")

AddOption("--enable-verbose", dest="verbose", action="store_true", default=False,
          help="Configure WiredTiger to support the verbose configuration string to wiredtiger_open")

AddOption("--enable-zlib", dest="zlib", type="string", nargs=1, action="store",
          help="Use zlib compression")

AddOption("--prefix", dest="prefix", type="string", nargs=1, action="store", default="package",
          help="Install directory")

AddOption("--with-berkeley-db", dest="bdb", type="string", nargs=1, action="store",
          help="Berkeley DB install path, ie, /usr/local")

# Get the swig binary from the command line option since SCONS cannot find it automatically
#
swig_binary = GetOption("lang-python")

# Initialize environment
#
var = Variables()

var.Add('MSVC_USE_SCRIPT', 'Path to vcvars.bat to override SCons default VS tool search');

var.Add('CPPPATH', 'C Preprocessor include path', [
    "#/src/include/",
    "#/build_win",
    "#/test/windows",
    "#/.",
])

var.Add('CFLAGS', 'C Compiler Flags', [
    "/Z7", # Generate debugging symbols
    "/wd4090", # Ignore warning about mismatched const qualifiers
    "/wd4996", # Ignore deprecated functions
    "/W3", # Warning level 3
    #"/we4244", # Possible loss of data
    "/we4013", # Error on undefined functions
    #"/we4047", # Indirection differences in types
    #"/we4024", # Differences in parameter types
    #"/we4100", # Unreferenced local parameter
    "/TC", # Compile as C code
    #"/Od", # Disable optimization
    "/Ob1", # inline expansion
    "/O2", # optimize for speed
    "/GF", # enable string pooling
    "/EHsc", # extern "C" does not throw
    #"/RTC1", # enable stack checks
    "/GS", # enable security checks
    "/Gy", # separate functions for linker
    "/Zc:wchar_t",
    "/Gd",
    "/MD" if GetOption("dynamic-crt") else "/MT",
])

var.Add('LINKFLAGS', 'Linker Flags', [
    "/DEBUG", # Generate debug symbols
    "/INCREMENTAL:NO", # Disable incremental linking
    "/OPT:REF", # Remove dead code
    "/DYNAMICBASE",
    "/NXCOMPAT",
])

var.Add('TOOLS', 'SCons tools', [
    "default",
    "swig",
    "textfile"
])

var.Add('SWIG', 'SWIG binary location', swig_binary)

env = Environment(
    variables = var
)

env['STATIC_AND_SHARED_OBJECTS_ARE_THE_SAME'] = 1

useZlib = GetOption("zlib")
useSnappy = GetOption("snappy")
useLz4 = GetOption("lz4")
useBdb = GetOption("bdb")
useTcmalloc = GetOption("tcmalloc")
wtlibs = []

conf = Configure(env)
if not conf.CheckCHeader('stdlib.h'):
    print 'stdlib.h must be installed!'
    Exit(1)

if useZlib:
    conf.env.Append(CPPPATH=[useZlib + "/include"])
    conf.env.Append(LIBPATH=[useZlib + "/lib"])
    if conf.CheckCHeader('zlib.h'):
        conf.env.Append(CPPDEFINES=["HAVE_BUILTIN_EXTENSION_ZLIB"])
        wtlibs.append("zlib")
    else:
        print 'zlib.h must be installed!'
        Exit(1)

if useSnappy:
    conf.env.Append(CPPPATH=[useSnappy + "/include"])
    conf.env.Append(LIBPATH=[useSnappy + "/lib"])
    if conf.CheckCHeader('snappy-c.h'):
        conf.env.Append(CPPDEFINES=['HAVE_BUILTIN_EXTENSION_SNAPPY'])
        wtlibs.append("snappy")
    else:
        print 'snappy-c.h must be installed!'
        Exit(1)

if useLz4:
    conf.env.Append(CPPPATH=[useLz4 + "/include"])
    conf.env.Append(LIBPATH=[useLz4 + "/lib"])
    if conf.CheckCHeader('lz4.h'):
        conf.env.Append(CPPDEFINES=['HAVE_BUILTIN_EXTENSION_LZ4'])
        wtlibs.append("lz4")
    else:
        print 'lz4.h must be installed!'
        Exit(1)

if useBdb:
    conf.env.Append(CPPPATH=[useBdb+ "/include"])
    conf.env.Append(LIBPATH=[useBdb+ "/lib"])
    if not conf.CheckCHeader('db.h'):
        print 'db.h must be installed!'
        Exit(1)

if useTcmalloc:
    conf.env.Append(CPPPATH=[useTcmalloc + "/include"])
    conf.env.Append(LIBPATH=[useTcmalloc + "/lib"])
    if conf.CheckCHeader('gperftools/tcmalloc.h'):
        wtlibs.append("libtcmalloc_minimal")
        conf.env.Append(CPPDEFINES=['HAVE_LIBTCMALLOC'])
        conf.env.Append(CPPDEFINES=['HAVE_POSIX_MEMALIGN'])
    else:
        print 'tcmalloc.h must be installed!'
        Exit(1)

env = conf.Finish()

# Configure build environment variables
#
if GetOption("attach"):
    env.Append(CPPDEFINES = ["HAVE_ATTACH"])

if GetOption("diagnostic"):
    env.Append(CPPDEFINES = ["HAVE_DIAGNOSTIC"])

if GetOption("lang-python"):
    env.Append(LIBPATH=[distutils.sysconfig.PREFIX + r"\libs"])
    env.Append(CPPPATH=[distutils.sysconfig.get_python_inc()])

if GetOption("verbose"):
    env.Append(CPPDEFINES = ["HAVE_VERBOSE"])


# Build WiredTiger.h file
#
version_file = 'build_posix/aclocal/version-set.m4'

VERSION_MAJOR = None
VERSION_MINOR = None
VERSION_PATCH = None
VERSION_STRING = None

# Read the version information from the version-set.m4 file
for l in open(File(version_file).srcnode().abspath):
    if re.match(r'^VERSION_[A-Z]+', l):
        exec(l)

if (VERSION_MAJOR == None or
    VERSION_MINOR == None or
    VERSION_PATCH == None or
    VERSION_STRING == None):
    print "Failed to find version variables in " + version_file
    Exit(1)

wiredtiger_includes = """
        #include <sys/types.h>
        #include <stdarg.h>
        #include <stdint.h>
        #include <stdio.h>
    """
wiredtiger_includes = textwrap.dedent(wiredtiger_includes)
replacements = {
    '@VERSION_MAJOR@' : VERSION_MAJOR,
    '@VERSION_MINOR@' : VERSION_MINOR,
    '@VERSION_PATCH@' : VERSION_PATCH,
    '@VERSION_STRING@' : VERSION_STRING,
    '@uintmax_t_decl@': "",
    '@uintptr_t_decl@': "",
    '@off_t_decl@' : 'typedef int64_t wt_off_t;',
    '@wiredtiger_includes_decl@': wiredtiger_includes
}

wtheader = env.Substfile(
    target='wiredtiger.h',
    source=[
        'src/include/wiredtiger.in',
    ],
    SUBST_DICT=replacements)

#
# WiredTiger library
#
filelistfile = r'build_win\filelist.win'
filelist = open(filelistfile)
wtsources = [line.strip()
             for line in filelist
             if not line.startswith("#") and len(line) > 1]
filelist.close()

if useZlib:
    wtsources.append("ext/compressors/zlib/zlib_compress.c")

if useSnappy:
    wtsources.append("ext/compressors/snappy/snappy_compress.c")

if useLz4:
    wtsources.append("ext/compressors/lz4/lz4_compress.c")

wt_objs = [env.Object(a) for a in wtsources]

# Static Library - libwiredtiger.lib
#
wtlib = env.Library(
    target="libwiredtiger",
    source=wt_objs, LIBS=wtlibs)

env.Depends(wtlib, [filelistfile, version_file])

# Dynamically Loaded Library - wiredtiger.dll
#
wtdll = env.SharedLibrary(
    target="wiredtiger",
    source=wt_objs + ['build_win/wiredtiger.def'], LIBS=wtlibs)

env.Depends(wtdll, [filelistfile, version_file])

Default(wtlib, wtdll)

wtbin = env.Program("wt", [
    "src/utilities/util_backup.c",
    "src/utilities/util_cpyright.c",
    "src/utilities/util_compact.c",
    "src/utilities/util_create.c",
    "src/utilities/util_drop.c",
    "src/utilities/util_dump.c",
    "src/utilities/util_list.c",
    "src/utilities/util_load.c",
    "src/utilities/util_load_json.c",
    "src/utilities/util_loadtext.c",
    "src/utilities/util_main.c",
    "src/utilities/util_misc.c",
    "src/utilities/util_printlog.c",
    "src/utilities/util_read.c",
    "src/utilities/util_rebalance.c",
    "src/utilities/util_rename.c",
    "src/utilities/util_salvage.c",
    "src/utilities/util_stat.c",
    "src/utilities/util_upgrade.c",
    "src/utilities/util_verbose.c",
    "src/utilities/util_verify.c",
    "src/utilities/util_write.c"],
    LIBS=[wtlib] + wtlibs)

Default(wtbin)

# Python SWIG wrapper for WiredTiger
if GetOption("lang-python"):
    # Check that this version of python is 64-bit
    #
    if sys.maxsize < 2**32:
        print "The Python Interpreter must be 64-bit in order to build the python bindings"
        Exit(1)

    pythonEnv = env.Clone()
    pythonEnv.Append(SWIGFLAGS=[
            "-python",
            "-threads",
            "-O",
            "-nodefaultctor",
            "-nodefaultdtor",
            ])

    swiglib = pythonEnv.SharedLibrary('_wiredtiger',
                      [ 'lang\python\wiredtiger.i'],
                      SHLIBSUFFIX=".pyd",
                      LIBS=[wtlib] + wtlibs)

    copySwig = pythonEnv.Command(
        'lang/python/wiredtiger/__init__.py',
        'lang/python/wiredtiger.py',
        Copy('$TARGET', '$SOURCE'))
    pythonEnv.Depends(copySwig, swiglib)

    swiginstall = pythonEnv.Install('lang/python/wiredtiger/', swiglib)

    Default(swiginstall, copySwig)

# Shim library of functions to emulate POSIX on Windows
shim = env.Library("window_shim",
        ["test/windows/windows_shim.c"])



examples = [
    "ex_access",
    "ex_all",
    "ex_async",
    "ex_call_center",
    "ex_config",
    "ex_config_parse",
    "ex_cursor",
    "ex_data_source",
    "ex_encrypt",
    "ex_extending",
    "ex_hello",
    "ex_log",
    "ex_pack",
    "ex_process",
    "ex_schema",
    "ex_scope",
    "ex_stat",
    "ex_thread",
    ]

# WiredTiger Smoke Test support
# Runs each test in a custom temporary directory
def run_smoke_test(x):
    print "Running Smoke Test: " + x

    # Make temp dir
    temp_dir = tempfile.mkdtemp(prefix="wt_home")

    try:
        # Set WT_HOME environment variable for test
        os.environ["WIREDTIGER_HOME"] = temp_dir

        # Run the test
        ret = subprocess.call(x);
        if( ret != 0):
            sys.stderr.write("Bad exit code %d\n" % (ret))
            raise Exception()

    finally:
        # Clean directory
        #
        shutil.rmtree(temp_dir)

def builder_smoke_test(target, source, env):
    run_smoke_test(source[0].abspath)
    return None

env.Append(BUILDERS={'SmokeTest' : Builder(action = builder_smoke_test)})

#Build the tests and setup the "scons test" target

#Don't test bloom on Windows, its broken
t = env.Program("t_bloom",
    "test/bloom/test_bloom.c",
    LIBS=[wtlib] + wtlibs)
#env.Alias("check", env.SmokeTest(t))
Default(t)

#env.Program("t_checkpoint",
    #["test/checkpoint/checkpointer.c",
    #"test/checkpoint/test_checkpoint.c",
    #"test/checkpoint/workers.c"],
    #LIBS=[wtlib])

t = env.Program("t_huge",
    "test/huge/huge.c",
    LIBS=[wtlib] + wtlibs)

#t = env.Program("t_recovery",
#    "test/recovery/recovery.c",
#    LIBS=[wtlib] + wtlibs)
#Default(t)

t = env.Program("t_fops",
    ["test/fops/file.c",
    "test/fops/fops.c",
    "test/fops/t.c"],
    LIBS=[wtlib, shim] + wtlibs)
env.Append(CPPPATH=["test/utility"])
env.Alias("check", env.SmokeTest(t))
Default(t)

if useBdb:
    benv = env.Clone()

=== src/third_party/mozjs-38/extract/js/src/devtools/gctrace/Makefile ===
# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, You can obtain one at http://mozilla.org/MPL/2.0/.

gcstats: gcstats.cpp ../../gc/GCTraceFormat.h Makefile
	$(CXX) -std=c++11 -g -O2 -I../.. -o $@ $<

=== debian/changelog ===
juju-mongodb3.2 (3.2.4-0ubuntu1) xenial; urgency=medium

  [ Curtis C. Hovey ]
  * New upstream release (LP #1557852)
  * d/control:
    - Do not build i386 and armhf because upstream will
      not support 32-bit.
    - Added system packages to build deps to avoid embedded packages.
    - Added lsb-release build dep
  * d/rules
    - Build wiredtiger
    - Use embedded libboost when building trusty.
  * d/install: Install binaries to /usr/lib/juju/mongo3.2/bin.
  * Updated d/p
    - Revised arch and kernel enablement patches
      + 0001-Create-kfreebsd-like-linux-in-most-respects.patch
      + 0002-kfreebsd-has-dev-urandom.patch
      + 0010-fix-integer-signs.patch
      + 0012-support-gnu.patch
    - Add patches to address compilation issues
      + disable-warnings.patch
      + fix-signed-checks.patch
      + offset-outside-of-bounds.patch
    - Added patches to support archs
      + scons-detect-ppc64.patch
      + support-ppc64el-mozjs.patch
      + use-4kb-sector-size-for-direct-io.patch
      + fix-debug-non-jit-builds-of-spidermonkey.patch
      + processinfo_test-fails-on-ppc64.patch
      + dont-assume-char-is-unsigned-in-logging.patch
      + use-signed-char-explicitly.patch
      + warn-user-if-locked-memory-limit-is-too-low.patch
      + skip-high-mem-test.patch
      + arm64-immediate-delete-should-wait-cursor.patch

   [ Michael Hudson-Doyle ]
   * Update packaging to 3.2.4 release.
   * Added d/patches/s390x-support.patch

 -- Curtis C. Hovey <curtis.hovey@canonical.com>  Tue, 15 Mar 2016 14:12:07 +0000

juju-mongodb2.6 (2.6.10-0ubuntu1) xenial; urgency=medium

  * New upstream release (LP #1557830).
  * Updated d/ based on 1:2.6.10-0ubuntu1 d/
  * d/control: 
    - Renamed source and binary package to juju-mongodb2.6.
    - Install to /usr/lib/juju/mongo2.6/bin/
    - Add libyaml-cpp-dev to BD's.
  * d/rules: Enable --with-system-yaml option. 
  * d/p 
    - Synced upstream patches with the mongodb 1:2.6.10-0ubuntu1
    - dropped be-port because juju 1.25 and juju-mongodb will not
      support s390x and powerpc; juju2 will support these archs.

 -- Curtis C. Hovey <curtis.hovey@canonical.com>  Tue, 15 Mar 2015 17:24:48 +0000

juju-mongodb (2.4.10-0ubuntu4) wily; urgency=medium

  * Fix FTBFS: (LP: #1483400)
    - Add 00git_boost_1.56.patch: Fix "std::swap" failure with current boost.
      (Backported from upstream git)
    - Add 00git_pymongo3.patch: Fix buildscripts/smoke.py for PyMongo 3.
      (Backported from upstream git)
    - Add no-unused-variable.patch: Don't fail to build on "unused-variable"
      warning.

 -- Martin Pitt <martin.pitt@ubuntu.com>  Tue, 11 Aug 2015 10:57:23 +0200

juju-mongodb (2.4.10-0ubuntu3) wily; urgency=medium

  * No-change rebuild against libpcrecpp0v5

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 08 Aug 2015 23:35:48 +0000

juju-mongodb (2.4.10-0ubuntu2) vivid; urgency=medium

  * d/p/no-unused-function.patch: Patch to avoid FTBFS with gcc-4.9 by using
    -Wno-unused-function. Patch cherry-picked from mongodb package in Vivid. 

 -- Oleg Strikov <oleg.strikov@canonical.com>  Mon, 20 Apr 2015 13:55:27 +0000

juju-mongodb (2.4.10-0ubuntu1) utopic; urgency=medium

  * New upstream release.

 -- James Page <james.page@ubuntu.com>  Wed, 30 Apr 2014 08:59:21 +0100

juju-mongodb (2.4.9-0ubuntu3) trusty; urgency=medium

  * d/p/0099-Pagesize-hacks.patch: Apply some hacks for non-4k pages.

 -- Adam Conrad <adconrad@ubuntu.com>  Thu, 27 Mar 2014 00:47:53 -0600

juju-mongodb (2.4.9-0ubuntu2) trusty; urgency=medium

  * d/tests/binaries: Drop check for mongo binary.

 -- James Page <james.page@ubuntu.com>  Wed, 22 Jan 2014 16:39:13 +0000

juju-mongodb (2.4.9-0ubuntu1) trusty; urgency=medium

  * New upstream point release.
  * d/p/0003-SERVER-12064-Use-gcc-atomic-builtins-if-available.patch:
    Dropped - not really needed for this version on mongodb.
  * d/install: Don't ship mongo binary, its broken without a JS engine
    (LP: #1270098).
  * d/p/0005-disable-jstests.patch: Dropped in preference to updates to
    d/p/0001-Add-option-to-disable-javascript.patch - rebased on revised
    upstream pull request.
  * d/rules: Don't strip binaries during build so we get a ddeb.

 -- James Page <james.page@ubuntu.com>  Wed, 22 Jan 2014 14:52:36 +0000

juju-mongodb (2.4.8-0ubuntu6) trusty; urgency=medium

  * Switch back to running standard smoke test suite, minus jstests:
    - d/rules: Use smoke target for test execution.
    - d/patches/0005-disable-jstests.patch: Disable jstests suite.

 -- James Page <james.page@ubuntu.com>  Tue, 07 Jan 2014 21:51:41 +0000

juju-mongodb (2.4.8-0ubuntu5) trusty; urgency=medium

  * Enable better support for alternative architectures:
    - 0001-SERVER-12064-Atomic-operations-for-gcc-non-Intel-arc.patch
      0002-SERVER-12065-Support-ARM-and-AArch64-builds.patch
      0003-SERVER-12064-Use-gcc-atomic-builtins-if-available.patch:
      Cherry picked changes from Robie Basak to enable atomic operations
      on non-Intel architectures.
    - 0004-Support-ppc64el-builds.patch: Add support for detection of
      powerpc64 as a 64-bit platform.
    - d/control: Enable arm64 and ppc64el architectures.

 -- James Page <james.page@ubuntu.com>  Tue, 07 Jan 2014 16:47:27 +0000

juju-mongodb (2.4.8-0ubuntu4) trusty; urgency=medium

  * Disable javascript scripting support:
    - d/rules: Pass --disable-scripting, drop config options for v8 and sm,
      only run C++ based tests during smoke testing.
    - d/p/0001-Add-option-to-disable-javascript.patch: Cherry picked changes 
      from Michael Hudson to add support for disabling javascript support.

 -- James Page <james.page@ubuntu.com>  Tue, 07 Jan 2014 14:48:30 +0000

juju-mongodb (2.4.8-0ubuntu3) trusty; urgency=medium

  * d/rules: Ignore test failures when testing with spidermonkey
    scripting engine for the time being.
  * d/control: Drop dependency on adduser as its not required.

 -- James Page <james.page@ubuntu.com>  Thu, 19 Dec 2013 16:37:23 +0000



=== debian/control ===
Source: juju-mongodb3.2
Section: database
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
Build-Depends:
 debhelper (>= 9),
 libboost-date-time-dev,
 libboost-dev (>> 1.50),
 libboost-filesystem-dev,
 libboost-program-options-dev,
 libboost-regex-dev,
 libboost-thread-dev,
 libgoogle-perftools-dev [linux-amd64],
 libpcap-dev,
 libpcre3-dev,
 libreadline-dev,
 libsnappy-dev,
 libssl-dev,
 libyaml-cpp-dev,
 lsb-release,
 python-pymongo,
 python-yaml,
 scons,
 valgrind,
 zlib1g-dev
Standards-Version: 3.9.5
Homepage: http://www.mongodb.org
XS-Testsuite: autopkgtest

Package: juju-mongodb3.2
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: MongoDB object/document-oriented database for Juju
 MongoDB is a high-performance, open source, schema-free
 document-oriented data store that's easy to deploy, manage
 and use. It's network accessible, written in C++ and offers
 the following features:
 .
    * Collection oriented storage - easy storage of object-style data
    * Full index support, including on inner objects
    * Query profiling
    * Replication and fail-over support
    * Efficient storage of binary data including large objects (e.g. videos)
    * Auto-sharding for cloud-level scalability
 .
 High performance, scalability, and reasonable depth of
 functionality are the goals for the project.
 .
 This package provides the mongod and mongos binaries for use within Juju,
 the service orchestration for Ubuntu.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DEB_SCONS_OPTIONS :=
ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
	DEB_SCONS_OPTIONS := --d=DEBUGBUILD
endif
ifneq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	DEB_SCONS_OPTIONS := --d=DEBUGBUILD
endif
ifneq (,$(findstring parallel,$(DEB_BUILD_OPTIONS)))
       PROCS=$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
       DEB_SCONS_OPTIONS += -j$(PROCS)
endif

HARDENING_OPTIONS = CC="$(CC)" CFLAGS="$(CFLAGS)" \
  CXX="$(CXX)" CXXFLAGS="$(CXXFLAGS)"
COMMON_OPTIONS = --use-system-snappy --use-system-pcre \
  --use-system-yaml --use-system-valgrind \
  --use-system-zlib --ssl --nostrip $(DEB_SCONS_OPTIONS)

ifneq ($(shell lsb_release -cs | sed -r 's/trusty/old/'),old)
	COMMON_OPTIONS += --use-system-boost
endif

gperftools_archs = amd64
ifneq (,$(filter $(DEB_HOST_ARCH), $(gperftools_archs)))
	COMMON_OPTIONS += --allocator=tcmalloc --use-system-tcmalloc
else
	COMMON_OPTIONS += --allocator=system
endif

# JUJU NOTE: disable javascript scripting support in the server; do not
# install the client.
COMMON_OPTIONS += --server-js=off

export DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

DEB_SCONS_CLEAN = --directory="." $(HARDENING_OPTIONS) . --keep-going --clean \
  $(COMMON_OPTIONS)
DEB_SCONS_BUILD = --directory="." $(HARDENING_OPTIONS) all $(COMMON_OPTIONS)
DEB_SCONS_INSTALL = --directory="." $(HARDENING_OPTIONS) \
  --prefix=$(CURDIR)/debian/tmp/usr install $(COMMON_OPTIONS)

override_dh_clean:
	scons $(DEB_SCONS_CLEAN) || :
	find $(CURDIR)/ -name "*.pyc" -delete
	rm -rf $(CURDIR)/debian/tmp-test/
	rm -rf $(CURDIR)/.scons/
	rm -rf $(CURDIR)/build/
	rm -f $(CURDIR)/failfile.smoke $(CURDIR)/smoke-last.json
	dh_clean

ifeq (,$(findstring nocheck, $(DEB_BUILD_OPTIONS)))
override_dh_auto_build:
	scons $(DEB_SCONS_BUILD)
endif

ifeq (,$(findstring nocheck, $(DEB_BUILD_OPTIONS)))
override_dh_auto_test:
	buildscripts/resmoke.py --suites=unittests \
		--dbpathPrefix $(CURDIR)/debian/tmp-test --storageEngine=mmapv1
endif

override_dh_auto_install:
	scons $(DEB_SCONS_INSTALL)

%:
	dh $@ --parallel

.PHONY: override_dh_clean override_dh_auto_build override_dh_auto_test \
	override_dh_auto_install

## juju-mongodb3.2 3.2.9

=== debian/changelog ===
juju-mongodb3.2 (3.2.9-0ubuntu1) yakkety; urgency=medium

  * New upstream release. (LP: #1605976) (again)
  * Drop one part of s390x-support.patch that was included upstream.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Tue, 30 Aug 2016 11:40:44 +1200

juju-mongodb3.2 (3.2.8-0ubuntu3) yakkety; urgency=medium

  * Fix ftbfs: (LP: #1610767):
    - Add d/patches/gcc6-ftbfs.patch to fix 2 warnings and 1 error.
    - Add d/patches/SERVER-16221-SERVER-23712-Aggregation-unit-tests-sho.patch,
      backported from master.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Mon, 08 Aug 2016 13:41:08 +1200

juju-mongodb3.2 (3.2.8-0ubuntu2) yakkety; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 04 Aug 2016 08:20:02 +0000

juju-mongodb3.2 (3.2.8-0ubuntu1) yakkety; urgency=medium

  * New upstream release. (LP: #1605976)
  * Drop patches which are now included upstream:
    - offset-outside-of-bounds.patch
    - scons-detect-ppc64.patch
    - use-4kb-sector-size-for-direct-io.patch
    - fix-debug-non-jit-builds-of-spidermonkey.patch
    - processinfo_test-fails-on-ppc64.patch
    - dont-assume-char-is-unsigned-in-logging.patch
    - use-signed-char-explicitly.patch
    - warn-user-if-locked-memory-limit-is-too-low.patch
  * Drop d/patches/skip-high-mem-test.patch, that test now passes on Launchpad
    builders.
  * Regenerate s390x-support.patch.
  * Explicitly enable mmapv1 on all architectures except s390x.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Tue, 26 Jul 2016 11:41:46 +1200

juju-mongodb3.2 (3.2.4-0ubuntu4) yakkety; urgency=medium

  * Include mongo client for admins and developer. (LP: #1583740)

 -- Curtis C. Hovey <curtis@hovey.name>  Tue, 17 May 2016 01:58:48 +0000

juju-mongodb3.2 (3.2.4-0ubuntu3) yakkety; urgency=medium

  * Cherrypick upstream commit 92c3f80f384d2825efeabd0d26aa534c0deb6988 to
    fix FTBFS with boost 1.60.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 26 Apr 2016 20:07:15 +0100

juju-mongodb3.2 (3.2.4-0ubuntu2) yakkety; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 23 Apr 2016 18:40:09 +0000

=== debian/rules ===
--- 
+++ 
@@ -31,6 +31,10 @@
 	COMMON_OPTIONS += --allocator=tcmalloc --use-system-tcmalloc
 else
 	COMMON_OPTIONS += --allocator=system
+endif
+
+ifneq ($(DEB_HOST_ARCH), s390x)
+	COMMON_OPTIONS += --mmapv1=on
 endif
 
 # JUJU NOTE: disable javascript scripting support in the server; do not

## juju-mongodb3.2 3.2.12

=== SConstruct ===
--- 
+++ 
@@ -13,6 +13,8 @@
 import uuid
 from buildscripts import utils
 from buildscripts import moduleconfig
+
+import SCons
 
 from mongo_scons_utils import (
     default_buildinfo_environment_data,
@@ -129,11 +131,6 @@
 #   using the nargs='const' mechanism.
 #
 
-add_option('mute',
-    help='do not display commandlines for compiling and linking, to reduce screen noise',
-    nargs=0,
-)
-
 add_option('prefix',
     default='$BUILD_ROOT/install',
     help='installation prefix',
@@ -182,6 +179,14 @@
     nargs=0
 )
 
+add_option('mmapv1',
+    choices=['auto', 'on', 'off'],
+    default='auto',
+    help='Enable MMapV1',
+    nargs='?',
+    type='choice',
+)
+
 add_option('wiredtiger',
     choices=['on', 'off'],
     const='on',
@@ -236,6 +241,15 @@
     type='choice',
 )
 
+add_option('spider-monkey-dbg',
+    choices=['on', 'off'],
+    const='on',
+    default='off',
+    help='Enable SpiderMonkey debug mode',
+    nargs='?',
+    type='choice',
+)
+
 add_option('opt',
     choices=['on', 'off'],
     const='on',
@@ -259,14 +273,11 @@
     nargs=0,
 )
 
-if is_running_os('linux') or is_running_os('windows'):
-   defaultAllocator = 'tcmalloc'
-else:
-    defaultAllocator = 'system'
-
 add_option('allocator',
-    default=defaultAllocator,
-    help='allocator to use (tcmalloc or system)',
+    choices=["auto", "system", "tcmalloc"],
+    default="auto",
+    help='allocator to use (use "auto" for best choice for current platform)',
+    type='choice',
 )
 
 add_option('gdbserver',
@@ -413,8 +424,10 @@
 )
 
 add_option('cache',
+    choices=["all", "nolinked"],
+    const='all',
     help='Use an object cache rather than a per-build variant directory (experimental)',
-    nargs=0,
+    nargs='?',
 )
 
 add_option('cache-dir',
@@ -435,8 +448,6 @@
     for path in sys.path:
         probe = os.path.join(path, 'mongo_custom_variables.py')
         if os.path.isfile(probe):
-            if not has_option('mute'):
-                print "Using mongo variable customization file {0}".format(probe)
             files.append(probe)
     return files
 
@@ -478,6 +489,3 @@
 except IOError as e:
     # If the file error wasn't because the file is missing, error out
     if e.errno != errno.ENOENT:
-        print "Error opening version.json: {0}".format(e.strerror)
-        Exit(1)
-

=== src/third_party/wiredtiger/SConstruct ===
--- 
+++ 
@@ -214,6 +214,7 @@
 wiredtiger_includes = """
         #include <sys/types.h>
         #include <stdarg.h>
+        #include <stdbool.h>
         #include <stdint.h>
         #include <stdio.h>
     """
@@ -239,12 +240,29 @@
 #
 # WiredTiger library
 #
-filelistfile = r'build_win\filelist.win'
-filelist = open(filelistfile)
-wtsources = [line.strip()
-             for line in filelist
-             if not line.startswith("#") and len(line) > 1]
-filelist.close()
+# Map WiredTiger build conditions: any conditions that appear in WiredTiger's
+# dist/filelist must appear here, and if the value is true, those files will be
+# included.
+#
+condition_map = {
+    'ARM64_HOST' : False,
+    'POSIX_HOST' : env['PLATFORM'] == 'posix',
+    'POWERPC_HOST' : False,
+    'WINDOWS_HOST' : env['PLATFORM'] == 'win32',
+    'X86_HOST' : True,
+    'ZSERIES_HOST' : False,
+}
+
+def filtered_filelist(f):
+    for line in f:
+        file_cond = line.split()
+        if line.startswith("#") or len(file_cond) == 0:
+            continue
+        if len(file_cond) == 1 or condition_map[file_cond[1]]:
+            yield file_cond[0]
+
+filelistfile = r'dist/filelist'
+wtsources = list(filtered_filelist(open(filelistfile)))
 
 if useZlib:
     wtsources.append("ext/compressors/zlib/zlib_compress.c")
@@ -276,6 +294,7 @@
 Default(wtlib, wtdll)
 
 wtbin = env.Program("wt", [
+    "src/utilities/util_alter.c",
     "src/utilities/util_backup.c",
     "src/utilities/util_cpyright.c",
     "src/utilities/util_compact.c",
@@ -345,12 +364,12 @@
     "ex_all",
     "ex_async",
     "ex_call_center",
-    "ex_config",
     "ex_config_parse",
     "ex_cursor",
     "ex_data_source",
     "ex_encrypt",
     "ex_extending",
+    "ex_file_system",
     "ex_hello",
     "ex_log",
     "ex_pack",
@@ -392,37 +411,11 @@
 
 #Build the tests and setup the "scons test" target
 
+testutil = env.Library('testutil',
+            [
+                'test/utility/misc.c',
+                'test/utility/parse_opts.c'
+            ])
+
 #Don't test bloom on Windows, its broken
 t = env.Program("t_bloom",
-    "test/bloom/test_bloom.c",
-    LIBS=[wtlib] + wtlibs)
-#env.Alias("check", env.SmokeTest(t))
-Default(t)
-
-#env.Program("t_checkpoint",
-    #["test/checkpoint/checkpointer.c",
-    #"test/checkpoint/test_checkpoint.c",
-    #"test/checkpoint/workers.c"],
-    #LIBS=[wtlib])
-
-t = env.Program("t_huge",
-    "test/huge/huge.c",
-    LIBS=[wtlib] + wtlibs)
-
-#t = env.Program("t_recovery",
-#    "test/recovery/recovery.c",
-#    LIBS=[wtlib] + wtlibs)
-#Default(t)
-
-t = env.Program("t_fops",
-    ["test/fops/file.c",
-    "test/fops/fops.c",
-    "test/fops/t.c"],
-    LIBS=[wtlib, shim] + wtlibs)
-env.Append(CPPPATH=["test/utility"])
-env.Alias("check", env.SmokeTest(t))
-Default(t)
-
-if useBdb:
-    benv = env.Clone()
-

=== debian/changelog ===
juju-mongodb3.2 (3.2.12-0ubuntu1~16.10) yakkety; urgency=medium

  * Backport to 16.10. (LP: #1673652)
  * Drop d/patches/fix-boost-1.62-build.patch.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Thu, 16 Mar 2017 20:13:57 +1300

juju-mongodb3.2 (3.2.12-0ubuntu1) zesty; urgency=medium

  * New upstream release. (LP: #1670891)
  * Do not use CRC32 instructions on s390x.
  * Correct architecture detection on arm64.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Wed, 08 Mar 2017 13:50:17 +1300

juju-mongodb3.2 (3.2.9-0ubuntu3) zesty; urgency=medium

  * Import Gentoo patch to fix FTBFS with boost1.62.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 08 Nov 2016 15:14:12 +0000

juju-mongodb3.2 (3.2.9-0ubuntu2) zesty; urgency=high

  * No change rebuild against boost1.62.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 01 Nov 2016 16:24:42 +0000

## juju-mongodb3.2 3.2.15

=== debian/changelog ===
juju-mongodb3.2 (3.2.15-0ubuntu1~16.04.1) xenial; urgency=medium

  * Backport to Xenial. (LP: #1699354)
  * Drop d/patches/fix-boost-1.62-build.patch.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Mon, 10 Jul 2017 15:48:40 +1200

juju-mongodb3.2 (3.2.15-0ubuntu1) artful; urgency=medium

  * New upstream release. (LP: #1699354)

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Mon, 10 Jul 2017 11:48:35 +1200

juju-mongodb3.2 (3.2.14-0ubuntu1) artful; urgency=medium

  * New upstream release.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Wed, 14 Jun 2017 20:20:14 +1200

juju-mongodb3.2 (3.2.13-0ubuntu1) artful; urgency=medium

  * New upstream release.
  * Remove two hunks from d/patches/gcc6-ftbfs.patch, now fixed upstream.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Wed, 26 Apr 2017 09:10:34 +1200

=== debian/rules ===
--- 
+++ 
@@ -33,7 +33,9 @@
 	COMMON_OPTIONS += --allocator=system
 endif
 
-ifneq ($(DEB_HOST_ARCH), s390x)
+ifeq ($(DEB_HOST_ARCH), s390x)
+	COMMON_OPTIONS += --use-s390x-crc32=off
+else
 	COMMON_OPTIONS += --mmapv1=on
 endif

=== debian/tests/control ===
Tests: binaries
Depends: juju-mongodb3.2
